//
// Copyright 2022 The ANGLE Project Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
//
// capture_gl_2_params.cpp:
//   Pointer parameter capture functions for the OpenGL 2.x entry points.

#include "libANGLE/capture/capture_gl_2_autogen.h"

namespace gl
{
// GL 2.0
void CaptureGetVertexAttribdv_params(const State &glState,
                                     bool isCallValid,
                                     GLuint index,
                                     GLenum pname,
                                     GLdouble *params,
                                     angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib1dv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLdouble *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib1sv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLshort *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib2dv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLdouble *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib2sv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLshort *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib3dv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLdouble *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib3sv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLshort *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Nbv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLbyte *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Niv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLint *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Nsv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLshort *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Nubv_v(const State &glState,
                                bool isCallValid,
                                GLuint index,
                                const GLubyte *v,
                                angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Nuiv_v(const State &glState,
                                bool isCallValid,
                                GLuint index,
                                const GLuint *v,
                                angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4Nusv_v(const State &glState,
                                bool isCallValid,
                                GLuint index,
                                const GLushort *v,
                                angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4bv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLbyte *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4dv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLdouble *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4iv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLint *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4sv_v(const State &glState,
                              bool isCallValid,
                              GLuint index,
                              const GLshort *v,
                              angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4ubv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLubyte *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4uiv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLuint *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}
void CaptureVertexAttrib4usv_v(const State &glState,
                               bool isCallValid,
                               GLuint index,
                               const GLushort *v,
                               angle::ParamCapture *paramCapture)
{
    UNIMPLEMENTED();
}

}  // namespace gl
